import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * This class defines a crab. Crabs live on the beach. They like sand worms 
 * (very yummy, especially the green ones).
 * 
 * Version: 2
 * 
 * In this version, the crab walks around the beach more or less randomly.
 */

public class Crab extends Animal
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private GreenfootImage image3;
    private int wormsEaten;
 
    
    /**
     * Animates the crab
     */
    
    public Crab()
    {
        
        image1 = new GreenfootImage("crab.png");
        image2 = new GreenfootImage("crab2.png");
        image3 = new GreenfootImage("crabdead.png");
        
        setImage(image1);
    }
    
    /** 
     * Act - do whatever the crab wants to do. This method is called whenever
     *  the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkKeypress();
        eat();        
    }
    
    public void animateCrab()
    {
        if (getImage() == image1 )
        {
            setImage(image2);
        }
        if (canSee(Lobster.class))
        {
            setImage(image3);
            Greenfoot.playSound("au.wav");
            Greenfoot.stop();
        }
        else
        {
            setImage(image1);
        }
       
    }
    
    /**
     * controls the crab
     */   
    
    public void checkKeypress()
    {
        if ( Greenfoot.isKeyDown("left") )
        {
            turn(-6);
            animateCrab();
        }
        if ( Greenfoot.isKeyDown("right") )
        {
            turn(6);
            animateCrab();
        }
        if ( Greenfoot.isKeyDown("up") )
        {
            move();
            animateCrab();
        }
        if ( Greenfoot.isKeyDown("down") )
        {
            turn(180);
            move();
            turn(-180);
            animateCrab();
        }
    }
        
     /**
     * eat - if the crab can do so, it will. 
     * After eating eight worms, it will spawn eight more worms and another lobster
     */
    
    public void eat()
    {
        if ( canSee(Worm.class) )
        {
            eat(Worm.class);
            Greenfoot.playSound("slurp.wav");
            wormsEaten = wormsEaten + 1;
           
            if (wormsEaten % 8 == 0)
            {
                Greenfoot.playSound("fanfare.wav");
                reSpawn();
            }
        }
    }
 

        
    
     /**
     * Creates another eight worms and an extra lobster
     */ 
    
    public void reSpawn()
    {
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Worm(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
        getWorld().addObject( new Lobster(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
    }
}


